"""
    NewsCatcher
    ==========

This is a caching object that reads data from a news-source
and provides recently cached data on request as a tuple for
use with a the dtml-in tag or similar.
"""
# $Id: NewsCatcher.py,v 1.2 2001/10/21 13:32:42 adrian Exp $
#
# $Log: NewsCatcher.py,v $
# Revision 1.2  2001/10/21 13:32:42  adrian
# no message
#
#
__version__ = '$Revision: 1.2 $'[11:-2]

import Globals
import OFS.SimpleItem
import OFS.PropertyManager
import Persistence
import Parsers

manage_addNewsCatcherForm = Globals.HTMLFile('www/addNewsCatcher', globals())
def manage_addNewsCatcher(self, id, title='', parser='', REQUEST=None, submit=None):
    """ Add a NewsCatcher object """
    obj = NewsCatcher(str(id), str(title), str(parser))
    self._setObject(obj.getId(), obj)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit==" Add and Edit ": u="%s/%s" % (u, urllib.quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_workspace')
    return ''

class NewsCatcher(
        OFS.PropertyManager.PropertyManager,
        OFS.SimpleItem.SimpleItem,
        Persistence.Persistent,
    ):
    """ """

    id = "NewsCatcher"
    title = "News Catcher"
    meta_type = "News Catcher"

    _properties = (
        {'id': 'title', 'type': 'string', 'mode': 'w'},
        {'id': 'parser', 'type': 'selection', 'mode': 'w',
         'select_variable': 'getParsers'},
    )

    def __init__(self, id, title, parser):
        """ Initialize this NewsCatcher object """
	self.id = id
	self.title = title
	self.parser = Parsers.ParserList[parser]

    def getParsers(self):
        """ Return a list of alll the registered parsers """
	list = Parsers.ParserList.keys()
	list.sort()
	return list

    def __call__(self):
        """ Return the cached news """
	return ()

# This class fires a thread when it is created.
# Every time Zope starts, this object has it's thread started.

class NewsUpdater(
        OFS.PropertyManager.PropertyManager,
        OFS.SimpleItem.SimpleItem,
        Persistence.Persistent,
    ):
    """ """

    def __init__(self):
        """ Initialize NewsUpdater """
        self.__p_Thread = None

