"""
    News Desk Product - BBC News File Decoder
    
File Format:

<DIV ID="stories">
  <DIV ID="1">
    <DIV ID=_NAME_>_VALUE_</DIV>
    <DIV ID=_NAME_>_VALUE_</DIV>
    <DIV ID=_NAME_>_VALUE_</DIV>
  </DIV>
  <DIV ID="1">
    <DIV ID=_NAME_>_VALUE_</DIV>
    <DIV ID=_NAME_>_VALUE_</DIV>
    <DIV ID=_NAME_>_VALUE_</DIV>
  </DIV>
</DIV>
<DIV ID="properties">
  <DIV ID="itemcount">2</DIV>
</DIV>
"""
# $Id: BBC.py,v 1.2 2001/10/21 13:35:00 adrian Exp $
#
# $Log: BBC.py,v $
# Revision 1.2  2001/10/21 13:35:00  adrian
# no message
#
#
__version__ = '$Revision: 1.2 $'[11:-2]

import sgmllib
import BaseParser

class BBC(sgmllib.SGMLParser, BaseParser.BaseParser):
    """ A NewsTag/NewsCatcher parser for the BBC's Live News Feeds """
    name = 'BBC'
    server = 'news.bbc.co.uk'
    sample = 'ticker_3_-1_-1_252.inc'
    sources = {
        'News': '/ticker/ticker_3_-1_-1_252.inc',
        'Sport': '/ticker/ticker_3_-1_-1_2513.inc',
    }

    def __init__(self, server=None, source=None, sample=None):
        """ """
        self.outsideData = ''         
        self.inStories = 0
        self.currentStory = 0
        self.currentStoryDict = {}
        self.currentItem = ''
        self.currentItemValue = ''
        sgmllib.SGMLParser.__init__(self, 0)
        BaseParser.BaseParser.__init__(self, server, source, sample)

    def feed(self, data):
        """ Feed the data into the parser data stack """
        sgmllib.SGMLParser.feed(self, data)
    
    def start_div(self, attrs):
        """ Work out what we are playing at """
        if attrs:
            for k, v in attrs:
                if k=='id':
                    myValue = v
            if self.inStories:
                if self.currentStory:
                    if self.currentItem:
                        raise "News data structure too deep", ""
                    else:
                        self.currentItem = myValue
                else:
                    self.currentStory = myValue
            else:
                if myValue=='stories':
                    self.inStories = 1
                    self.Stories = []
        
    def handle_data(self, data):
        """ Store the block value against the current div id """
        if self.inStories:
            if self.currentStory:
                if self.currentItem:
                    self.currentItemValue = "%s%s" % (self.currentItemValue, data)
        else:
            self.outsideData = "%s%s" % (self.outsideData, data)
    
    def end_div(self):
        """ Pop the last div off the stack """
        if self.inStories:
            if self.currentStory:
                if self.currentItem:
                    if self.currentItemValue:
                        self.currentStoryDict[self.currentItem] = self.currentItemValue
                    self.currentItem = ''
                    self.currentItemValue = ''
                    return
                self.Stories.append(self.currentStoryDict)
                self.currentStory = 0
                self.currentStoryDict = {}
                return
            self.inStories = 0

    def close(self):
        """ Close the input stream and process the received data """
        sgmllib.SGMLParser.close(self)
        for c in self.Stories:
            if c['SiteLink'][:5] != 'http:':
                c['SiteLink'] = "http://%s%s" % (self.server, c['SiteLink'])
            if c['UrlLink'][:5] != 'http:':
                c['UrlLink'] = "http://%s%s" % (self.server, c['UrlLink'])
            c['url'] = c['UrlLink']
            try:
                c['headline'] = c['LinksTo']
            except:
                c['headline'] = "BBC News Lead Story"
            c['body'] = c['Summary']

BaseParser.registerParser(BBC)
