"""
    News Desk Product - E-Commerce Times File Decoder
    
File Format:

^^setSpeed (90)
^^setBackgroundColor (0,156,222)
^^setForegroundColor (0,0,0)
^^setFontFace (arial)
^^setFontSize (11)
^^setCenter (false)
^^setBold (false)

^^setForegroundColor (0, 0, 0)
^^setURL(http://www.ecommercetimes.com)


^^setCenter (true)

^^setForegroundColor (255, 255, 255)
^^setFontFace (arial)
^^setFontSize (12)
^^setBold (true)
^^setCenter (true)
Brought To You By
The
E-Commerce Times
^^setForegroundColor (255, 255, 255)

^^setCenter (true)
^^pause (2500)

^^setCenter (true)


TechNewsWorld.com
^^setForegroundColor (0, 0, 0)
^^setFontFace (arial)
^^setFontSize (11)
^^setBold (false)
Click Here For
Up to the Minute
News Updates From
Around the World
^^setURL(http://www.technewsworld.com)
^^setCenter (true)
^^pause (3500)
^^setForegroundColor (255, 255, 255)
^^setFontFace (arial)
^^setFontSize (12)
^^setBold (true)
^^setCenter (true)
"""
# $Id: ECT.py,v 1.2 2001/10/21 13:35:00 adrian Exp $
#
# $Log: ECT.py,v $
# Revision 1.2  2001/10/21 13:35:00  adrian
# no message
#
#
__version__ = '$Revision: 1.2 $'[11:-2]

from string import strip, split
import re
import BaseParser

class ECT(BaseParser.BaseParser):
    """ """
    name = 'ECT'
    server = 'www.ecommercetimes.com'
    sample = 'headlines-1.txt'
    sources = {
        'default': '/ticker_headlines/headlines-1.txt',
    }
    
    def close(self):
        """ """
        splitterRE = re.compile('\^\^pause.*?\(.*?\).*?\n', re.I | re.M | re.S)
        urlRE = re.compile('.*\^\^setURL.*?[(](.*?)[)].*?\n', re.I | re.M | re.S)
        self.data = re.sub('[\r\n]+', '\n', self.data)
        sifted = splitterRE.split(self.data)
        for Item in sifted:
            urlM = urlRE.match(Item)
            if urlM:
                url = urlM.group(1)
            headline = ''
            body = ''
            inSect = 0  # 0=none, 1=Head, 2=None, 3=Body, 4=none
            for Line in split(Item, '\n'):
                Line = re.sub('\n', '', Line)
                Line = strip(Line)
                if not Line:
                    pass
                elif Line[:2] == '^^':
                    if inSect == 0:
                        pass
                    elif inSect == 1:
                        inSect = 2
                        pass
                    elif inSect == 3:
                        inSect = 4
                        pass
                else:
                    if inSect == 0 or inSect == 1:
                        inSect = 1
                        headline = headline + ' ' + Line
                    elif inSect == 2 or inSect == 3:
                        inSect = 3
                        body = body + ' ' + Line
            self.Stories.append({'url': url, 'headline': strip(headline), 'body': strip(body)})

BaseParser.registerParser(ECT)
